<?php
/**
 * @package cSprites for Wordpress
 * @author Adrian Mummey
 * @version 0.1
 */

function cSpriteAdminMenu() {
  add_options_page('cSprites Options', 'cSprites', 8, __FILE__, 'cSpriteOptionsPage');
}

function cSpriteOptionsPage(){

?>
<div class="wrap">
<h2><?php _e('cSprites for Wordpress');?></h2>

<form method="post" action="options.php">
<?php wp_nonce_field('update-options'); ?>

<table class="form-table">

<tr valign="top">
<th scope="row"><label for="jpgQuality"><?php _e('JPG Quality');?></label></th>
<td><input type="text" name="jpgQuality" id="jpgQuality" value="<?php echo get_option('jpgQuality'); ?>" class="regular-text code"/><span class="setting-description"><?php _e('0 lowest - 100 highest (Default: 70)');?></span></td>
</tr>
 
<tr valign="top">
<th scope="row"><label for="pngCompression"><?php _e('PNG Compression');?></label></th>
<td><input type="text" id="pngCompression" name="pngCompression" value="<?php echo get_option('pngCompression'); ?>" class="regular-text code"/><span class="setting-description"><?php _e('1 lowest - 9 highest (Default: 9)');?></span></td>
</tr>

<tr valign="top">
<th scope="row"><label for="cacheTime"><?php _e('Cache Time in Minutes');?></label></th>
<td><input type="text" name="cacheTime" id="cacheTime" value="<?php echo get_option('cacheTime'); ?>" class="regular-text code"/><span class="setting-description"><?php _e('set to 0 for no cache (Default: 20)');?></span></td>
</tr>


<tr valign="top">
<th scope="row"><label for="forceNoPadding"><?php _e('Force no padding in image style');?></label></th>
<td><select name="forceNoPadding" id="forceNoPadding"/>
      <option value="1"><?php _e('True');?></option>
      <option value="0" <?php echo (get_option('forceNoPadding'))?(''):('selected'); ?> ><?php _e('False');?></option>
    </select>
    <span class="setting-description"><?php _e('setting this to true will add a <em>padding:0 !important;</em> style to each image class; this will prevent padding from exposing other parts of the sprite. (Default: true)');?></span>
    </td>
</tr>

</table>

<input type="hidden" name="action" value="update" />
<input type="hidden" name="page_options" value="jpgQuality,pngCompression,cacheTime,forceNoPadding" />

<p class="submit">
<input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
</p>

</form>
</div>
<?php 

} //end function 
?>