<?php
/**
 * @package cSprites for Wordpress
 * @author Adrian Mummey
 * @version .4
 */

/*
Plugin Name: cSprites for Wordpress
Plugin URI: http://wordpress.org/extend/plugins/csprites-for-wordpress/
Description: Automatically compress you content images into a big sprite, decreasing web page load time.
Version: .4
Author: Adrian Mummey
Author URI: http://mummey.org/

*/

function findImg($content){
  $matches = array();
  $imgs = preg_match_all("/<img[^>]* src=('|\")([^\"]*)('|\")[^>]*>/i", $content, $matches);
  if(isset($matches[2])){
    foreach($matches[2] as $imgSource){
      //Lets get rid of dynamic images
      
        Sprite::ppRegister($imgSource);
      
    }
    Sprite::process();
  }  
  return $content;
}

function imgReplace($content){
  $matches = array();
  $pattern = array();
  /*$img_regex = '/<img[\s]+[^>]*?((class*?[\s]?=[\s\"\']+(.*?)[\"\']+.*?)|(src*?[\s]?=[\s\"\']+(.*?)[\"\']+.*?))((src*?[\s]?=[\s\"\']+(.*?)[\"\']+.*?>)|(class*?[\s]?=[\s\"\']+(.*?)[\"\']+.*?>)|>)/i';*/
  $img_regex = '/<img[\s]+[^>]*?(.*?)((class*?[\s]?=[\s\"\']+(.*?)[\"\']+.*?)|(src*?[\s]?=[\s\"\']+(.*?)[\"\']+.*?))(.*?)((src*?[\s]?=[\s\"\']+(.*?)[\"\']+(.*?)>)|(class*?[\s]?=[\s\"\']+(.*?)[\"\']+(.*?)>)|>)/i';
  $content = preg_replace_callback($img_regex, 'cSpriteReplacement', $content);
  return $content;
}
function cSpriteReplacement($matches){
 // var_dump($matches);
  $blankGif = SpriteConfig::get('transparentImagePath');
  if(@$matches[13]){
    $src = $matches[6];
    $class = $matches[13];
    $spriteClass = Sprite::styleClass($src);
    if(!$spriteClass){
      return $matches[0];
    }
    $returnString =  '<img src="'.$blankGif.'" '.$matches[1].' class="'.$class.' '.$spriteClass.'" '.$matches[7].' ' .$matches[14].'/>';
  }
  else if(@$matches[10]){
    $src = $matches[10];
    $class = $matches[4];
    $spriteClass = Sprite::styleClass($src);
    if(!$spriteClass){
      return $matches[0];
    }

    $returnString =  '<img src="'.$blankGif.'" '.$matches[1].' class="'.$class.' '.$spriteClass.'" '.$matches[7].' ' .$matches[11].'/>';
  }
  else{
    $src = $matches[6];
    $spriteClass = Sprite::styleClass($src);
    if(!$spriteClass){
      return $matches[0];
    }

    $returnString =  '<img src="'.$blankGif.'" '.$matches[1].' class="'.$spriteClass.'" '.$matches[7].'/>';
  }
  return $returnString;
}
function cspriteStyles(){
	$cstyles = "
	<!-- begin wpcsprites scripts -->
	<script type=\"text/javascript\">
    //<![CDATA[
    document.write('<link rel=\"stylesheet\" href=\"". get_bloginfo('wpurl')."/wp-content/plugins/csprites-for-wordpress".SpriteStyleRegistry::getRelativePath()."\" type=\"text/css\" media=\"screen\" />');
    //]]>
    </script>
	<!-- end wpcsprites scripts -->\n";
  echo $cstyles; 

}

function updatecSpriteOptions(){
  $imagePropertiesOrig = SpriteConfig::get('imageProperties');
  add_option('cSpriteJpgQuality', $imagePropertiesOrig['jpgQuality']);
  add_option('cSpritePngCompression', $imagePropertiesOrig['pngCompression']);
  add_option('cSpriteCacheTime', SpriteConfig::get('cacheTime'));
  add_option('cSpriteForceNoPadding', SpriteConfig::get('forceNoPadding'));

  $imageProperties['jpgQuality'] = (is_numeric(get_option('cSpriteJpgQuality')))?(get_option('cSpriteJpgQuality')):($imagePropertiesOrig['jpgQuality']);
  $imageProperties['pngCompression'] = (is_numeric(get_option('cSpritePngCompression')))?(get_option('cSpritePngCompression')):($imagePropertiesOrig['pngCompression']);
  
  SpriteConfig::set('imageProperties', $imageProperties);
  SpriteConfig::set('cacheTime', (is_numeric(get_option('cacheTime')))?(get_option('cSpriteCacheTime')):(20));
  SpriteConfig::set('forceNoPadding', get_option('cSpriteForceNoPadding'));
}
/*cSprites config*/
if (version_compare(PHP_VERSION, '5.0.0', '>')) {
  define('SPRITE_CONFIG_FILE', ABSPATH.'wp-content/plugins/csprites-for-wordpress/config.yml');
  require_once('includes/options.php');
  require_once('includes/uninstall.php');
  require_once('csprites/Sprite.php');
  SpriteConfig::set('rootDir', ABSPATH.'wp-content/plugins/csprites-for-wordpress');
  SpriteConfig::set('transparentImagePath', get_bloginfo('wpurl')."/wp-content/plugins/csprites-for-wordpress/1_1_trans.gif");
  SpriteConfig::set('cssImagePath', get_bloginfo('wpurl')."/wp-content/plugins/csprites-for-wordpress");
  
  updatecSpriteOptions();
  add_filter('the_content', 'findImg', 500);
  add_filter('the_content', 'imgReplace', 501);
  add_action('wp_footer', 'cspriteStyles');
  add_action('admin_menu', 'cSpriteAdminMenu');
	
}

?>